.module Program
.var uword, CurrentLayout
.var uword, CurrentLayoutProgPtr
Main

	; Initial setup.
	im 1
	xor a
	ld (curCol),a
	ld (curRow),a
	set appAutoScroll, (iy+appFlags)
	bcall(_ForceFullScreen)
	

	; First of all, check if there are any programs available:
-	ld ix,ProgramHeaderForIon
	ld hl,(progPtr)
	call DetectNextVersioned
	jr z,LayoutExists
	call CreateNewLayoutMessage
	ret nz
	jr {-} ; Force redetection.

LayoutExists
	ld (CurrentLayoutProgPtr),de
	ld (CurrentLayout),hl

RedrawMainInterface
	call ClearUpper

	; Draw the toolbar.	
	ld hl,Toolbar1
	call DrawToolbar
	
	ld hl,(CurrentLayout)
	inc hl
	ld bc,16
	ld de,saveSScreen
	ldir
	xor a
	ld (de),a
	ld hl,saveSScreen
	bcall(_StrLength)
	ld a,c
	add a,a
	ld c,a
	add a,a
	add a,c
	dec a
	ld c,a
	ld a,95
	sub c
	srl a
	
	ld (penCol),a
	ld a,24
	ld (penRow),a
	
	ld hl,saveSScreen
	
	set fracDrawLFont,(iy+fontFlags)
	bcall(_VPutS)
	res fracDrawLFont,(iy+fontFlags)

MainLoop

	; Handle transmission...
	call Keys.GetPressed
	jr nz,{+}
	
	call GetLayoutDataAddress
	ld a,(hl)
	or a
	jr z,MainLoop ; No key.
	
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld c,(hl)
	
	ld b,6
	call SonyIR.WriteMultiple
	
	jr MainLoop
+
	bcall(_GetCSC)
	halt

	cp skYEqu
	jr nz,{+}
	
	ld ix,ProgramHeaderForIon
	ld hl,(CurrentLayoutProgPtr)
	call DetectNextVersioned
	jr z,FoundNext
	ld ix,ProgramHeaderForIon
	ld hl,(progPtr)
	call DetectNextVersioned
FoundNext
	ld (CurrentLayoutProgPtr),de
	ld (CurrentLayout),hl
	jp RedrawMainInterface
+

	cp skWindow
	jr nz,{+}
	call CreateNewLayoutMessage
	jp RedrawMainInterface
+

	cp skZoom
	jp z,Editor

	cp skTrace
	jr nz,{+}
	ld a,4
	call DrawMessage
	jp MainLoop
+
	
	cp skGraph
	ret z
	jp MainLoop

Toolbar1 .db "Device   New   Edit   About   Exit",0	
Toolbar2 .db "Back",6,6,6,6,6,6,"Key",6,6,6,"   Rename",0

DrawToolbar
	ld a,(iy+textFlags)
	push af
	
	push hl

	ld hl,0+55*256
	ld de,95+63*256
	bcall(_FillRect)
	ld hl,2+(64-8)*256
	ld (penCol),hl
	
	pop hl
	
	set textInverse,(iy+textFlags)
	bcall(_VPutS)
	
	pop af
	ld (iy+textFlags),a
	ret


; Main editor loop
.var uword, EditedData
.var ubyte, EditField
.var ubyte, EditKey
Editor

	xor a
	ld (EditField),a

	call ClearUpper
	ld hl,Toolbar2
	call DrawToolbar	

	ld a,5
	ld b,1
	call DisplayMessage

-	bcall(_GetCSC)
	halt
	cp skYEqu
	jp z,ExitEditor
	cp skGraph
	jp z,RenameDevice
	call Keys.GetPressed
	jr nz,{-}


	ld (EditKey),a

StartEditingKey


	ld a,(EditKey)
	
	
	call ionFastCopy
	
	.var ubyte[48], KeyEditCaption
	ld hl,EditKeyCaption
	ld de,KeyEditCaption
	ld bc,EditKeyCaptionLength
	ldir
	
	ld a,(EditKey)
	
	push de
	call Keys.GetName
	pop de
	
-	ld a,(hl)
	ldi
	or a
	jr nz,{-}
	
	ld bc,KeyEditCaption	
	ld hl,4+22*256
	ld de,90+48*256
	call Dialogs.DrawWithTitle
	
	ld a,3
	ld (curRow),a
	
	ld hl,EditorFields
	ld b,3
-	ld a,2
	ld (curCol),a
	push bc
	bcall(_PutS)
	pop bc
	ld a,(curRow)
	inc a
	ld (curRow),a
	djnz {-}
	
	
	ld a,(EditKey)
	call GetLayoutDataAddress
	ld (EditedData),hl
	
RedrawEditField
	
	ld a,(EditField)
	add a,3
	ld (curRow),a
	ld a,1
	ld (curCol),a
	ld a,LblockArrow
	bcall(_PutC)

RedrawDirtyData
	ld hl,(EditedData)
	
	ld de,3+11*256
	ld (curRow),de

	ld a,(hl)
	inc hl
	
	or a
	jr z,KeyIsOff

	push hl
	call DispA
	pop hl

	ld de,4+10*256
	ld (curRow),de
	
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	call DispDEHex
	pop hl

	ld de,5+12*256
	ld (curRow),de
	
	ld a,(hl)
	call DispAHex
	jr KeyIsOn
KeyIsOff
	
	ld a,3
	ld (curRow),a
	
--	ld a,10
	ld (curCol),a
	ld b,4
-	ld a,' '
	bcall(_PutC)
	djnz {-}
	ld a,(curRow)
	inc a
	ld (curRow),a
	cp 6
	jr nz,{--}

KeyIsOn
	
-	bcall(_GetCSC)
	cp skZoom
	jp z,Editor
	cp skYEqu
	jp z,ExitEditor
	cp skGraph
	jp z,RenameDevice
	
	cp skEnter
	jp z,DoEditField
	
	cp skUp
	jr z,ChangeEditField
	cp skDown
	jr z,ChangeEditField
	
	call SonyIR.Read
	jr nz,{-}
	
	ld hl,(EditedData)
	ld (hl),a
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ld (hl),c
	jr RedrawDirtyData


ChangeEditField
	push af
	ld a,(EditField)
	add a,3
	ld (curRow),a
	ld a,1
	ld (curCol),a
	ld a,' '
	bcall(_PutC)
	ld a,14
	ld (curCol),a
	ld a,' '
	bcall(_PutC)
	ld a,(EditField)
	ld b,a
	pop af
	ld c,-1
	cp skUp
	jr z,{+}
	ld c,+1
+	ld a,b
	add a,c
	cp 3
	jp z,RedrawEditField
	cp -1
	jp z,RedrawEditField
	ld (EditField),a
	jp RedrawEditField

DoEditField

	ld a,(EditField)
	or a
	jr nz,NotBitCount
	
	ld hl,(EditedData)
	push hl
	ld a,(hl)
	ld hl,BitCountCycle
	ld bc,5
	cpir
	ld a,(hl)
	pop hl
	ld (hl),a
	
	jp RedrawDirtyData
	
NotBitCount

	ld hl,(EditedData)
	push hl
	pop ix
		
	push af
	push af

	bcall(_ZeroOP1)
	ld hl,OP1

	pop af
	dec a
	jr nz,IsControl
	ld e,(ix+1)
	ld d,(ix+2)
	call StringDEHex
	jr WasDevice
IsControl
	ld a,(ix+3)
	call StringAHex
WasDevice	
	pop af
	add a,3
	ld (curRow),a
	sub 4
	add a,a
	add a,10
	ld (curCol),a
	ld b,a
	ld a,14
	sub b
	ld b,a
	
	ld hl,OP1
	ld a,TextInput.Modes.Hex
	
	push bc
	call TextInput.GetString
	
	ld hl,OP1
	bcall(_StrLength)
	ld a,c
	pop bc	
	cp b
	
	jr z,{+}
	ld a,6
	call DrawMessage
	jp StartEditingKey
+

	ld hl,OP1
	call DecodeDEString
	ld a,(EditField)
	dec a
	jr nz,SaveControl
	ld (ix+1),e
	ld (ix+2),d
	jr SavedDevice
SaveControl
	ld (ix+3),d
SavedDevice
	
	ld a,14
	ld (curCol),a
	ld a,' '
	bcall(_PutC)
	jp RedrawEditField

RenameDevice
	call ionFastCopy

	ld hl,4+30*256
	ld de,90+40*256
	ld bc,Rename
	call Dialogs.DrawWithTitle

	ld hl,4+1*256
	ld (curRow),hl

	ld hl,(CurrentLayout)
	inc hl
	ld a,TextInput.Modes.Free
	ld b,13
	
	call TextInput.GetString	
	jp RedrawMainInterface

ExitEditor
	call ionFastCopy
	jp RedrawMainInterface
	ret

BitCountCycle
	.db 0, 12, 15, 20, 0

EditorFields
.db "Length",0
.db "Device",0
.db "Command",0

EditKeyCaption .db "Edit Key: "
EditKeyCaptionLength = $-EditKeyCaption

Rename
.db "Rename Device",0

; Gets the address of command/device/length data from the current layout.
GetLayoutDataAddress
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld de,(CurrentLayout)
	add hl,de
	ld de,16
	add hl,de
	ret

; Create a new layout file, displaying an error message on failure.
; Returns Z on success, NZ on failure.
CreateNewLayoutMessage
	ld hl,plotSScreen
	bcall(_SaveDisp)
	call CreateNewLayout
	push af
	call ionFastCopy
	pop af
	ret z
	push af
	call DrawMessage
	pop af
	ret

; Create a new layout file.
; Each layout file follows the following structure...
; 6 bytes:   identifier "SonyIR"
; 1 byte:    version    1
; 16 bytes:  name       "Television",0,0,0,0,0,0
; 180 bytes: data       45 * [db bitlength, dw device, db command.]
; That's 202 bytes per layout.
CreateNewLayout
	ld hl,256
	bcall(_EnoughMem)
	jr nc,CanCreate
	ld a,1
	or a
	ret
CanCreate

	ld hl,4+30*256
	ld de,90+40*256
	ld bc,NewLayout
	call Dialogs.DrawWithTitle

	ld hl,1*256+4
	ld (curRow),hl
	ld hl,Name
	bcall(_PutS)
	bcall(_ZeroOP1)
	ld a,ProtProgObj
	ld (OP1),a
	ld hl,OP1+1
	ld b,8
	ld a,TextInput.Modes.Program
	call TextInput.GetString
	ld a,(OP1+1)
	or a
	jr nz,GotName
	inc a
	inc a ; message 2
	ret
GotName

	ld a,(OP1+1)
	ld hl,TextInput.Decimal
	ld bc,TextInput.DecimalLength
	cpir
	jr nz,{+}
	ld a,2
	inc a
	ret
+
	; Check if file already exists:
	bcall(_ChkFindSym)
	jr c,{+}
	ld a,0
	cp 1
	ret
+
	; Now we can create the layout file. :)
	ld hl,202
	bcall(_CreateProtProg)
	ld (CurrentLayoutProgPtr),hl
	inc de
	inc de
	ld h,d
	ld l,e
	push hl
	ld bc,202
	bcall(_MemClear)
	pop hl
	ld de,ProgramHeader
	ex de,hl
	ld bc,ProgramHeaderLength
	ldir
	dec de
	ld (CurrentLayout),de
	inc de
	ld hl,OP4+1
	ld bc,8
	ldir
	ld hl,(CurrentLayoutProgPtr)
	ld ix,ProgramHeaderForIon 
	call DetectNextVersioned
	ld (CurrentLayoutProgPtr),de
	cp a
	ret

NewLayout .db "New Layout",0
Name .db "Name ",0
ProgramHeader .db "SonyIR", 1
ProgramHeaderLength = $-ProgramHeader
ProgramHeaderForIon .db "SonyIR",0

DispDEHex
	ld hl,OP1
	call StringDEHex
	jr {+}
DispAHex
	ld hl,OP1
	call StringAHex
+	ld (hl),0
	ld hl,OP1
	bcall(_PutS)
	ret
	
StringDEHex
	push de
	ld a,d
	call StringAHex
	pop de
	ld a,e
StringAHex
	push af
	srl a
	srl a
	srl a
	srl a
	call StringNybble
	pop af
	and $F
StringNybble
	cp 10
	jr nc,{+}
	add a,'0'
	ld (hl),a \ inc hl
	ret
+	add a,'A'-10
	ld (hl),a \ inc hl
	ret

DecodeDEString
	call DecodeAString
	ld d,a
	call DecodeAString
	ld e,a
	ret
DecodeAString
	ld a,(hl)
	inc hl
	call DecodeNybbleString
	add a,a
	add a,a
	add a,a
	add a,a
	ld b,a
	ld a,(hl)
	inc hl
	call DecodeNybbleString
	or b
	ret
DecodeNybbleString
	sub "0"
	cp 10
	ret c
	sub 7
	ret

; Print A on the display in decimal (right-aligned, three characters).
DispA
	cp 10
	jr nc,Over10
	push af
	ld a,' '
	bcall(_PutC)
	bcall(_PutC)
	pop af
	jr LeftTwoSpaces	
Over10
	cp 100
	jr nc,Over100
	push af
	ld a,' '
	bcall(_PutC)
	pop af
	jr LeftSpace
Over100
	ld b,0
-	cp 100
	jr c,{+}
	inc b
	sub 100
	jr {-}
+	push af
	ld a,'0'
	add a,b
	bcall(_PutC)
	pop af
LeftSpace
	ld b,0
-	cp 10
	jr c,{+}
	inc b
	sub 10
	jr {-}
+	push af
	ld a,'0'
	add a,b
	bcall(_PutC)
	pop af
LeftTwoSpaces
	add a,'0'
	bcall(_PutC)
	ret

; Draw a message from the error number in a, wait for delay, restore background.
DrawMessage
	ld b,0
	call DisplayMessage
	jp ionFastCopy

; Display a message with error number in a.
DisplayMessage
	push bc
	push af
	ld hl,plotSScreen
	bcall(_SaveDisp)
	pop af
	pop bc
	ld hl,Resources.Messages
	jp Dialogs.DrawMessageFromTable

; Like ionDetect, but can filter out version numbers.	
DetectNextVersioned
	push ix
	call ionDetect ; Good old-fashioned ionDetect.
	pop ix
	ret nz ; None to be found.
	ld a,(hl)
	cp 1
	ret z
	ld h,d
	ld l,e
	jr DetectNextVersioned

; Clear the upper section of the display (ie, not the toolbar).
ClearUpper
	ld hl,0
	ld de,96+54*256
	bcall(_ClearRect)
	ret
	
; Other code and resources:
.include "SonyIR.asm"
.include "Keys.asm"
.include "TextInput.asm"
.include "Dialogs.asm"

.include "Resources/Resources.inc"
.endmodule